{ 020309N3a.PAS                                                            }
{ 2002-03-09 programmeerimieolu"mpiaadi noorema ru"hma                     }
{   3. u"lesande KASSA lahendus                                            }
{                                                                          }
{ Meelis Karp                                                              }
{ Testitud: TP 7.0, FPC 1.0.4                                              }

{
U"lesandes tuleb leida mingi rahasumma, kasutades seejuures vo~imalikult
va"he rahata"hti. U"lesande vo~ib lahendada kasutades ta"isla"bivaatust,
kuid nominaalide ja rahata"htede arvu suurenedes kasvab la"bi vaatamist
vajavate variantide hulk eksponentsiaalselt ning sellele kulub liiga
palju aega.
Otstarbekam on kasutada nn lainealgoritmi.
Moodustame rahata"htdest ko~ikvo~imalikud summad ning vaatame, milliste
rahata"htedega moodustub summa ko~ige optimaalsemalt. Ko~ikvo~imalike
summade kohta info hoidmiseks kasutame massiivi 10001-st elemendist
(indeksid 0 kuni 10000) ning selle i-ndasse elementi ma"rgime, kas antud
summa on saavutatav. Iga u"ksiku rahata"he korral ka"ime massiivi la"bi,
liidame igale juba saavutatud summale rahata"he va"a"rtuse ja ma"rgime
uue summa saavutatuks (summa on massiivi elemendi indeks). Kui ko~ik
rahata"hed on la"bi ka"idud, on massiivis kirjas ko~ik summad, mida nende
rahata"htedega on vo~imalik saavutada.
Kuna u"lesandes ei piisa ainult JAH/EI vastusest, peab olema iga saavutatava
summa korral vo~imalik kindlaks ma"a"rata, millistest liidetavatest ta saadi.
Selleks kirjutame massiivi iga saavutatud summa kohale mitte True/False, vaid
indeksi, millisest summast antud summa saadi.
Kuna ei piisa u"ksko~ik millisest summa saavutamise variandist, vaid lisaks
on veel tarvis, et summa oleks saadud va"hima arvu liidetavatega,
kirjutame iga summa juurde, mitme liidetavaga ta saavutati. Selle info
hoidmiseks vo~ib teha eraldi teise massiivi, kuid antud lahenduses on
kasutatud u"hte massiivi, mille elementideks on kirjed kahest va"ljast:
- Eelmine - summa, millest antud summa saavutati,
- Samme - liidetavate arv.
Kui avastame, et mingi summa on saavutatav va"hema liidetavate arvuga,
kui juba kirjas, siis kirjutame vastavasse kirjesse uue info.
Antud juhul alustatakse suurema nominaaliga rahata"htedest, sel juhul pa"rast
liidetavate leidmisel tulevad liidetavad nominaalide kasvamise ja"rjekorras.
Summade massiiv algva"a"rtustatakse ja"rgmiselt:
- va"li "Eelmine" algva"a"rtustatakse -1-dega vo~i mistahes mittesaavutatava
  summaga;
- va"li "Samme" algva"a"rtustaakse MaxInt-ga (32767) vo~i mistahes
  arvuga, mis oleks suurem vo~imalikust sammude arvust;
- massiivi 0-nda elemendi mo~lemad va"ljad algva"a"rtustatakse 0-ga, st
  summa "0" on saavutatav (summast "0") ilma u"hegi liidetavata.

Lahendus on optimiseeritud ja"rgmiselt:
- Vajalikust summast S suuremaid massiivi elemente ei vaadata, st lainega
  ka"iakse la"bi ainult summad, mis pole vajalikust summast
  suuremad. Kui eraldada massiivi jaoks ma"lu du"naamiliselt, ongi tarvis
  eraldada ainult 0..S elementide tarvis;
- Vajalikust summast S suurema indeksiga elemente ei muudeta, st
  kui mingi rahata"he liitmisel la"heks summa S-st suuremaks, ei tehta
  midagi (vt eelmine punkt);
- Peetakse meeles suurim juba saavutatud summa ja laine ka"igus suuremaid
  summasid la"bi ei vaadata (muutuja 'jarg');
- Mittevajalikke rahata"hti ei proovita, st kui mingi nominaaliga rahata"hega
  ei o~nnestunud laine jooksul saavutada u"htegi summat optimaalsemalt, kui
  juba enne oli saavutatud, liigutakse kohe ja"rgmise nominaali juurde
  (muutuja OnVaja);

}

Program KASSA;

Type SummadeTyyp=Record
                  Eelmine:Integer;
                  Samme:  Integer;
                 end;

Const MaxSumma=10000;
      MaxN=100;
      SisendFail='KASSA.SIS';
      ValjundFail='KASSA.VAL';
      Tyhi=-1;

Var Summad: array[0..MaxSumma] of SummadeTyyp;
    Nominaal: array[1..MaxN] of Integer;
    Raha:   array[1..MaxN] of Integer;
    S:      LongInt;  {summa, mis tarvis saavutada}
    N:      Integer;  {nominaalide arv}
    jarg:   LongInt;  {ja"rjehoidja}
    OnVaja: Boolean;
    i,j:    LongInt;  {tsyklimuutujad}
    f:      Text;

BEGIN
 {Loeme andmed sisse}
 Assign(f,SisendFail);
 Reset(f);
 Readln(f,N);
 For i:=1 to N do Read(f,Nominaal[i]);
 For i:=1 to N do Read(f,Raha[i]);
 Readln(f,S);
 Close(f);

 {Summade massiivi algva"a"rtustamine}
 Summad[0].Eelmine:=0; Summad[0].Samme:=0;
 for i:=1 to S do begin
  Summad[i].Eelmine:=Tyhi;
  Summad[i].Samme:=MaxInt;
 end;

 jarg:=0;
 For i:=N downto 1 do begin  {vaatame suuremast nominaalist va"iksema poole}
  OnVaja:=True;
  while OnVaja and (Raha[i]>0) do begin {kuni kupyyrid otsas vo~i enam panna ei saa}
   OnVaja:=False;
   for j:=jarg downto 0 do begin
    if Summad[j].Eelmine <> Tyhi then  {tyhjale kohale juurde ei liida}
     if (j+Nominaal[i] <= S) then      {vajalikust summast suuremaid ei vaata}
      if Summad[j+Nominaal[i]].Samme > Summad[j].Samme + 1 then begin
     {Kui antud summa saab saavutada va"hema sammude arvuga, kui senini teada}
       Summad[j + Nominaal[i]].Eelmine := j;
       Summad[j + Nominaal[i]].Samme := Summad[j].Samme + 1;
       OnVaja := True;
       if jarg < j+Nominaal[i] then jarg := j + Nominaal[i];
      end;
   end;
   Raha[i]:=Raha[i]-1;
  end;
  {Vaatame la"bi ko~ik nominaalid}
 end;

 {Vastuse va"ljastamine}
 {kui hakata summast tagurpidi minema, on nominaalid kasvavas ja"rjekorras}
 Assign(f,ValjundFail);
 Rewrite(f);
 jarg:=S;
 for i:=1 to N do begin
  Raha[i]:=0;
  while jarg-Summad[jarg].Eelmine = Nominaal[i] do begin
   Raha[i]:=Raha[i]+1;
   jarg:=Summad[jarg].Eelmine;
  end;
  Write(f,Raha[i]);
  if i<N then Write(f,' ');
 end;
 Writeln(f);
 Close(f);
END.
