{ 020309V2b.PAS                                                             }
{ 2002-03-09 programmeerimisolmpiaadi vanema rhma 4. lesande lahendus    }
{    TEKSTITOIMETI                                                          }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

const
   sisf = 'TEKST.SIS';
   valf = 'TEKST.VAL';
   maxn = 100;                                     { maksimaalne ridade arv }
   maxk = 100;                                    { maksimaalne kskude arv }

var
   n, k : integer;                                { ridade arv, kskude arv }
   t : array [1..maxn+maxk] of ^string;                          { read ise }
   p : string;                                                     { puhver }

{ lisab rea X ette thja rea }
procedure lisa(x : integer);
var i : integer;
begin
   for i := n downto x do                { nihutame jrgmisi ridu tahapoole }
      t[i + 1] := t[i];
   new(t[x]); t[x]^ := '';      { vtame uuele reale mlu ja algvrtustame }
   n := n + 1;                                        { ridade arv suurenes }
end;

{ kustutab rea X }
procedure kustuta(x : integer);
var i : integer;
begin
   dispose(t[x]);                                          { vabastame mlu }
   n := n - 1;                                         { ridade arv vhenes }
   for i := x to n do                    { nihutame jrgmisi ridu ettepoole }
      t[i] := t[i + 1];
end;

{ COPY X }
procedure tee_copy(x : integer);
begin
   p := t[x]^;                               { kopeerime rea sisu puhvrisse }
end;

{ CUT X }
procedure tee_cut(x : integer);
begin
   p := t[x]^;                               { kopeerime rea sisu puhvrisse }
   kustuta(x);                                     { kustutame rea tekstist }
end;

{ PASTE X }
procedure tee_paste(x : integer);
begin
   lisa(x);                                         { lisame teksti uue rea }
   t[x]^ := p;                                { kopeerime sinna puhvri sisu }
end;

{ SPLIT X Y }
procedure tee_split(x, y : integer);
begin
   lisa(x);                                         { lisame teksti uue rea }
   t[x]^ := copy(t[x + 1]^, 1, y - 1);       { poolitatava rea esimene pool }
   delete(t[x + 1]^, 1, y - 1);                { poolitatava rea teine pool }
end;

{ JOIN X }
procedure tee_join(x : integer);
begin
   t[x]^ := t[x]^ + t[x + 1]^;                          { paneme read kokku }
   kustuta(x + 1);                        { kustutame tagumise rea tekstist }
end;

{ loeb ja kustutab antud rea algusest thikuga lppeva tisarvu }
procedure loe_arv(var s : string; var x : integer);
var i, u : integer;
begin
   i := 1;
   while (i < length(s)) and (s[i] <> ' ') do
      i := i + 1;
   val(copy(s, 1, i - 1), x, u);
   delete(s, 1, i);
end;

{ tidab antud ksu }
procedure tee(s : string);
var x, y : integer;
begin
   s := s + ' ';
   if copy(s, 1, 5) = 'COPY ' then begin
      delete(s, 1, 5);
      loe_arv(s, x);
      tee_copy(x);
   end else if copy(s, 1, 4) = 'CUT ' then begin
      delete(s, 1, 4);
      loe_arv(s, x);
      tee_cut(x);
   end else if copy(s, 1, 6) = 'PASTE ' then begin
      delete(s, 1, 6);
      loe_arv(s, x);
      tee_paste(x);
   end else if copy(s, 1, 6) = 'SPLIT ' then begin
      delete(s, 1, 6);
      loe_arv(s, x);
      loe_arv(s, y);
      tee_split(x, y);
   end else if copy(s, 1, 5) = 'JOIN ' then begin
      delete(s, 1, 5);
      loe_arv(s, x);
      tee_join(x);
   end;
end;

var
   f : text;
   i : integer;
   s : string;

begin
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do begin
      new(t[i]);
      readln(f, t[i]^);
   end;

   p := '';
   readln(f, k);
   for i := 1 to k do begin
      readln(f, s);
      tee(s);
   end;
   close(f);

   assign(f, valf); rewrite(f);
   writeln(f, n);
   for i := 1 to n do
      writeln(f, t[i]^);
   close(f);
end.
