{ 020309V3c.PAS                                                             }
{ 2002-03-09 programmeerimisolmpiaadi vanema rhma 3. lesande lahendus    }
{    LINKER                                                                 }
{ Kirsto Tammeoja                                                           }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

{ Laiuti otsimise naiivne realisatsioon }

const
 {sisend- ja vljundfaili nimi}
 sisfail = 'linker.sis'; valfail = 'linker.val';
 MAX_TIPPE = 100; {maksimaalne tippude arv}
 MAX_SERVI = 1000; {maksimaalne servade arv}
 ARVU_MAX_PIKKUS = 200;
type
 arv = record
  n : integer; {(tve)numbrite arv suures arvus (0-l ks)}
  sign : shortint; {vastavalt -1, 0 vi 1, kui suur arv on
   negatiivne 0 vi positiivne}
  nr : array[1..ARVU_MAX_PIKKUS] of byte;
 end;
 serv = record
  algus, lopp, kaal : integer; {serva alg- ja lpptipp ning serva kaal}
 end;
var
 n, m : integer; {tippude ja servade arv}
 alg, lopp : integer; {alg- ja lpptipu indeksid}

 {servade hoidmiseks}
 servad : array[1..MAX_SERVI] of serv; {servad}
 tipud : array[1..MAX_TIPPE+1] of integer; {iga tipu kohta on kirjutatud,
  mitmendast positsioonist massiivis servad algab sellest tipust vljuvate
  servade kirjeldus (viimase tipu jrel on kirjas, mitmenda positsiooniga
  servade kirjeldus lppeb); seega i-ndast tipust algavad servad on
  massiivis servad indekitega vahemikus [ tipud[i] .. tipud[i+1] )  }

 {vastus}
 on_vastus : boolean;
 vkorrutis : arv; {vastusena antava tee servade kaalude korrutis}
 vjarglane : array[1..MAX_TIPPE] of integer; {iga tipu kohta kirjas vastusena
  antavas tees temale jrgneva tipu indeks}
 vtee_pikkus : integer; {vastusena antava tee pikkus}

 {lahendamise jaoks}
 {jargnevas on 0 lihtsuse mottes nii positiivne kui ka negatiivne}
 {iga tipu jaoks jetakse meelde...}
 pos : array[1..MAX_TIPPE] of arv; {...positiivne arv}
 neg : array[1..MAX_TIPPE] of arv; {...negatiivne arv}
 {...ning kas on ikkagi leitud ...}
 on_pos : array[1..MAX_TIPPE] of boolean; {...positiivne arv}
 on_neg : array[1..MAX_TIPPE] of boolean; {...negatiivne arv}
 {...millisest tipu kaudu saadi...}
 eelmine_pos : array[1..MAX_TIPPE] of integer; {...positiivne arv}
 eelmine_neg : array[1..MAX_TIPPE] of integer; {...negatiivne_arv}
    {eelmine on negatiivne, kui arvestati eellase negatiivset korrutist}




{============= ARVUTAMISEGA SEOTUD MEETODID ==================}

{seab arvule a vrtuseks 1}
procedure anna1(var a : arv);
begin
 a.n := 1; a.sign := 1; a.nr[1] := 1;
end; {anna1}


{korrutab arvu a b-ga (b on vahemikus [-100...100])
 tulemus kirjutatakse muutujasse v}
procedure korruta(var a : arv; b : integer; var v : arv);
var l, y : integer; {loendur; ylekanne korrutamisel}
begin
 if (a.sign=0) or (b=0) then begin {ks tegur on null}
  v.n := 1; v.sign := 0; v.nr[1] := 0;
 end else begin {kumbki teguritest pole null}
  {korrutise mrk...}
  if b>0 then v.sign := a.sign else v.sign := -a.sign;

  {esimese n tvenumbri arvutamine...}
  v.n := a.n; {minimaalne vastuse tvenumbrite arv}
  y := 0; {esimese arvu juures on ylekanne null}
  b := abs(b); {tulemuse mrk on juba mratud,
   korrutamisega leitakse vaid tulemuse absoluutvrtus}

  for l := 1 to a.n do begin {l-nda numbri arvutamine}
   y := y+a.nr[l]*b; {}
   v.nr[l] := y mod 10; {tulemuse l-s number}
   y := y div 10; {ylekanne jrgmise taseme jaoks}
  end; {for l}

  {kui y pole null, siis jrelikult on korrutis esimesest tegurist pikem;
   leiame ka vastuse kige esimesed tvenumbrid}
  while y>0 do begin {lekanne on suurem, kui null...}
   inc(v.n); {vastuses tuleb vhemalt ks number juurde panna}
   v.nr[v.n] := y mod 10; {uue numbri kirjapanek}
   y := y div 10; {lekanne jrgmise sammu jaoks}
  end; {while y>0}
 end; {else - kumbki teguritest pole null}
end; {korruta}


{kirjutab arvu parameetrina antud tekstifaili, reavahetust ei lisata}
procedure kirjuta_arv(var a : arv; var f : text);
var l : integer;
begin
 if a.sign=-1 then write(f,'-'); {negatiivse arvu ette '-'}
 {numbrite kirjutamine - tuleb lihtsalt eestpoolt alates tvenumbrid
  vlja kirjutada (a.n on arvu tvenumbrite arv)}
 for l := a.n downto 1 do write(f,a.nr[l]);
end;


{tagastab positiivse arvu, nulli vi negatiivse arvu vastavalt sellele,
 kas esimene arvu on teisega vrreldes suurem, vrdne vi viksem}
function vordle(var a, b : arv) : integer;
var t, l : integer;
begin
 if a.sign=b.sign then begin {arvud sama mrgiga}
  {tvenumbrite vrdlemisel pole mtet, kui arvud on nullid}
  if a.sign=0{=b.sign} then begin vordle := 0; exit; end;

  {jrgnevalt vrreldaks a ja b aboluutvrtusi, tegeliku tulemuse saamiseks
   korrutatakse vrdluse tulemus a mrgiga (sama, mis b-l)}

  {a ja b on mlemad kas positiivsed vi mlemad negatiivsed}
  if a.n<>b.n then begin {kui arvudel on erinev arv tvenumbreid...}
   vordle := a.sign*(a.n-b.n); exit;
  end;

  {arvudel sama arv tvenumbreid}
  t := 0; {siia salvestataks a ja b absoluutvrtuste vrdluse tulemus}
  for l := a.n downto 1 do {arve vrreldakse vasakult paremale}
   if a.nr[l]<>b.nr[l] then begin {kui leitakse erinevus...}
    t := a.nr[l]-b.nr[l]; break;
   end;

  {kui tskli sees tvenumbrites erinevust ei leitud, siis t=0,
   muidu on t-s a ja b absoluutvrtuste vrdlemise tulemus}
  vordle := a.sign*(t); exit;
 end else begin {a.sign<>b.sign - arvud pole sama mrgiga}
  vordle := a.sign-b.sign; exit;
 end;
end; {vordle}



{============== ANDMETE LUGEMINE =================}
procedure loe_andmed;
var
 sisf : text; {sisendfail}
 k, l : integer;
 servad_a : array[1..MAX_SERVI] of serv; {servade lugemiseks}
begin
 assign(sisf,sisfail); reset(sisf);
 {graafi tippude ja servade arv}
 readln(sisf,n,m);
 {servade andmet lugemine}
 for l := 1 to m do
  readln(sisf,servad_a[l].algus,servad_a[l].lopp,servad_a[l].kaal);
 {alg- ja lppunkti lugemine}
 readln(sisf,alg,lopp);
 close(sisf);

 {tippude lhedusvektorite loomine.,,}

 {sorteerimine serva algpunkti jrgi...}
 {iga tipu kohta leitakse, mitu serva temast vljub}
 for l := 1 to n+1 do tipud[l] := 0; {loendurite nullimine}
 for l := 1 to m do inc(tipud[servad_a[l].algus]); {servade loendamine}
 {iga tipu kohta leitaks esimese serva indeks tidetavas massiivis servad,
  mis ei vlju antud tipust}
 inc(tipud[1]);
 for l :=  2 to n+1 do tipud[l] := tipud[l]+tipud[l-1];
 {servade kopeerimine nende igesse kohta}
 for l := 1 to m do begin
  k := servad_a[l].algus; {vaadeldava serva algustipp}
  dec(tipud[k]);
  servad[tipud[k]] := servad_a[l]; {serva kopeerimine igesse kohta}
 end;
 {massiivis tipud on nutavad indeksid}
end; {loe_andmed}




{================== LAHENDAMINE ====================}
{tidetakse vastuse kohta kivad andmed}

{loeb genereeritud tulemustest vastuse. vastus peab leiduma
 kui argument on true, siis ptakse leida positiivse vastuse
 andnud teed, vastasel korral negatiivse vastuse andnud teed}
procedure loe_vastus(positiivne : boolean);
var
 jarglane, eellane : integer;
begin
 {viimase tipu saab kohe paika panna}
 vtee_pikkus := 1;
 vjarglane[lopp] := lopp;

 {vastus leitaks mda teed tagurpidi liikudes.
  muutujat jarglane kasutatakse vjarglane titmiseks}
 jarglane := lopp;
 if positiivne then begin
  eellane := eelmine_pos[lopp]; vkorrutis := pos[lopp];
 end else begin
  eellane := eelmine_neg[lopp]; vkorrutis := neg[lopp];
 end;

 {tee leidmine}
 while jarglane<>alg do begin
  inc(vtee_pikkus); {tee pikkus suurenes uue tipu lisamisega}
  {vastusesse tipule abs(eellane) jrglase kirjutamine}
  vjarglane[abs(eellane)] := jarglane;
  {etepoole liikumine}
  jarglane := abs(eellane);
  if eellane>0 then {vaadati eellase positiivset korrutist}
   eellane := eelmine_pos[abs(eellane)]
  else {vaadati eellase negatiivset korrutist}
   eellane := eelmine_neg[abs(eellane)];
 end; {while}
end; {loe_vastus}


{lahendamise peameetod}
procedure lahenda;
var l, k, t, s, kaal : integer; e : integer; a : arv;
 b : boolean; {true, kui on veel muudetud tippe}
begin
 on_vastus := false; {senini pole vastus leitud...}

 {////////////////////}
 {kui korrutis tuleb positiivne (arvestatakse absoluutvrtuselt
  suuremaid korrutisi)}

 {mrkida, et tippude kohta pole veel korrutisi leitud}
 for l := 1 to n do begin
  on_pos[l] := false; on_neg[l] := false;
 end;
 {esimese tipu paika panemine}
 on_pos[alg] := true; anna1(pos[alg]);
 eelmine_pos[alg] := alg; eelmine_neg[alg] := alg; {korrektsuse prast}

 {lahenduse arvutamine}
 b := true; {algtippu muudeti}

 while b do begin
  b := false; {b abil peame nyyd selgeks tegema, kas selle sammu korral
      (while-tsykli) muudeti monede tippude andmeid. algvaartus tsykli
      alguses on seega false - pole muudetud.
      jargnevas seatakse b true-ks kui kusagil muudetakse mingit tippu}

  for t := 1 to n do begin {koikide tippude korral}
   if t=lopp then continue; {viimast tippu tees pole mtet ttlema hakata}

   for k := tipud[t] to tipud[t+1]-1 do begin
    {tdeldavast tipust vljuvad servad}
    s := servad[k].lopp; {serva lopp-tipp}
    kaal := servad[k].kaal; {tdeldava serva kaal}

    if kaal>=0 then begin {serva kaal on positiivne (vi null)}
     {uue korrutise leidmine}

     {positiivse arvu leidmine...}
     if on_pos[t] then begin {kui positiivset arvu on vimalik saada}
      korruta(pos[t],kaal,a);
      {kui tulemus on suurem kui sihttipu eelmine}
      if (not on_pos[s]) or (vordle(pos[s],a)<0) then begin
       on_pos[s] := true; pos[s] := a; eelmine_pos[s] := t; b := true;
      end;
      {kui korrutis tuli 0, siis voib vastust vaadata (kui mingit
       negatiivset korrutist pole veel leitud) ka negatiivse arvuna}
      if (a.sign=0) and (not on_neg[s]) then begin
       on_neg[s] := true; neg[s] := a; eelmine_neg[s] := t; b := true;
      end;
     end; {if on_pos[t]}

     {negatiivse arvu leidmine...}
     if on_neg[t] then begin {kui negatiivset arvu on vimalik saada}
      korruta(neg[t],kaal,a);
      {kui tulemus on viksem kui sihttipu eelmine}
      if (not on_neg[s]) or (vordle(neg[s],a)>0) then begin
       on_neg[s] := true; neg[s] := a; eelmine_neg[s] := -t; b := true;
      end;
      {kui korrutis tuli 0, siis voib vastust vaadata (kui mingit
       positiivset korrutist pole veel leitud) ka positiivse arvuna}
      if (a.sign=0) and (not on_pos[s]) then begin
       on_pos[s] := true; pos[s] := a; eelmine_pos[s] := t; b := true;
      end;
     end; {if on_neg[t]}

    end else begin {serva kaal on negatiivne}
     {positiivse arvu leidmine...}
     if on_neg[t] then begin {kui positiivset arvu on vimalik saada}
      korruta(neg[t],kaal,a);
      {kui tulemus on suurem kui sihttipu eelmine}
      if (not on_pos[s]) or (vordle(pos[s],a)<0) then begin
       on_pos[s] := true; pos[s] := a; eelmine_pos[s] := -t; b := true;
      end;
      {kui korrutis tuli 0, siis voib vastust vaadata (kui mingit
       negatiivset korrutist pole veel leitud) ka negatiivse arvuna}
      if (a.sign=0) and (not on_neg[s]) then begin
       on_neg[s] := true; neg[s] := a; eelmine_neg[s] := t; b := true;
      end;
     end;

     {negatiivse arvu leidmine...}
     if on_pos[t] then begin {kui negatiivset arvu on vimalik saada}
      korruta(pos[t],kaal,a);
      {kui tulemus on viksem kui sihttipu eelmine}
      if (not on_neg[s]) or (vordle(neg[s],a)>0) then begin
       on_neg[s] := true; neg[s] := a; eelmine_neg[s] := t; b := true;
      end;
      {kui korrutis tuli 0, siis voib vastust vaadata (kui mingit
       positiivset korrutist pole veel leitud) ka positiivse arvuna}
      if (a.sign=0) and (not on_pos[s]) then begin
       on_pos[s] := true; pos[s] := a; eelmine_pos[s] := t; b := true;
      end;
     end;
    end; {if servad[k].kaal>=0}

   end; {for k}
  end; {for t}
 end; {while b}

 {kui leidub positiivse korrutisega tee...}
 if on_pos[lopp] then begin
  on_vastus := true; loe_vastus(true); exit;
 end;


 {////////////////////}
 {kui korrutis tuleb negatiivne (arvestatakse absoluutvrtuselt
  viksemaid korrutisi)}

 {mrkida, et tippude kohta pole veel korrutisi leitud}
 for l := 1 to n do begin
  on_pos[l] := false; on_neg[l] := false;
 end;
 {esimese tipu paika panemine}
 on_pos[alg] := true; anna1(pos[alg]);
 eelmine_pos[alg] := alg; eelmine_neg[alg] := alg; {korrektsuse prast}

 {lahenduse arvutamine}
 b := true; {algtippu muudeti}

 while b do begin
  b := false; {b abil peame nyyd selgeks tegema, kas selle sammu korral
      (while-tsykli) muudeti monede tippude andmeid. algvaartus tsykli
      alguses on seega false - pole muudetud.
      jargnevas seatakse b true-ks kui kusagil muudetakse mingit tippu}

  for t := 1 to n do begin {koikide tippude korral}
   if t=lopp then continue; {viimast tippu tees pole mtet ttlema hakata}

   for k := tipud[t] to tipud[t+1]-1 do begin
    {tdeldavast tipust vljuvad servad}
    s := servad[k].lopp; {serva lopp-tipp}
    kaal := servad[k].kaal; {tdeldava serva kaal}

    if kaal>=0 then begin {serva kaal on positiivne (vi null)}
     {positiivse arvu leidmine...}
     if on_pos[t] then begin {kui positiivset arvu on vimalik saada}
      korruta(pos[t],kaal,a);
      {kui tulemus on viksem kui sihttipu eelmine}
      if (not on_pos[s]) or (vordle(pos[s],a)>0) then begin
       on_pos[s] := true; pos[s] := a; eelmine_pos[s] := t; b := true;
      end;
      {kui korrutis tuli 0, siis voib vastust vaadata (kui mingit
       negatiivset korrutist pole veel leitud) ka negatiivse arvuna}
      if (a.sign=0) and (not on_neg[s]) then begin
       on_neg[s] := true; neg[s] := a; eelmine_neg[s] := t; b := true;
      end;
     end; {if on_pos[t]}

     {negatiivse arvu leidmine...}
     if on_neg[t] then begin {kui negatiivset arvu on vimalik saada}
      korruta(neg[t],kaal,a);
      {kui tulemus on suurem kui sihttipu eelmine}
      if (not on_neg[s]) or (vordle(neg[s],a)<0) then begin
       on_neg[s] := true; neg[s] := a; eelmine_neg[s] := -t; b := true;
      end;
      {kui korrutis tuli 0, siis voib vastust vaadata (kui mingit
       positiivset korrutist pole veel leitud) ka positiivse arvuna}
      if (a.sign=0) and (not on_pos[s]) then begin
       on_pos[s] := true; pos[s] := a; eelmine_pos[s] := t; b := true;
      end;
     end; {if on_neg[t]}

    end else begin {serva kaal on negatiivne}
     {positiivse arvu leidmine...}
     if on_neg[t] then begin {kui positiivset arvu on vimalik saada}
      korruta(neg[t],kaal,a);
      {kui tulemus on suurem kui sihttipu eelmine}
      if (not on_pos[s]) or (vordle(pos[s],a)>0) then begin
       on_pos[s] := true; pos[s] := a; eelmine_pos[s] := -t; b := true;
      end;
      {kui korrutis tuli 0, siis voib vastust vaadata (kui mingit
       negatiivset korrutist pole veel leitud) ka negatiivse arvuna}
      if (a.sign=0) and (not on_neg[s]) then begin
       on_neg[s] := true; neg[s] := a; eelmine_neg[s] := t; b := true;
      end;
     end;

     {negatiivse arvu leidmine...}
     if on_pos[t] then begin {kui negatiivset arvu on vimalik saada}
      korruta(pos[t],kaal,a);
      {kui tulemus on viksem kui sihttipu eelmine}
      if (not on_neg[s]) or (vordle(neg[s],a)<0) then begin
       on_neg[s] := true; neg[s] := a; eelmine_neg[s] := t; b := true;
      end;
      {kui korrutis tuli 0, siis voib vastust vaadata (kui mingit
       positiivset korrutist pole veel leitud) ka positiivse arvuna}
      if (a.sign=0) and (not on_pos[s]) then begin
       on_pos[s] := true; pos[s] := a; eelmine_pos[s] := t; b := true;
      end;
     end;
    end; {if servad[k].kaal>=0}

   end; {for k}
  end; {for t}
 end; {while b}

 {kui leidub negatiivse korrutisega tee...}
 if on_neg[lopp] then begin
  on_vastus := true; loe_vastus(false); exit;
 end;

end; {lahenda}



{================== VASTUSE KIRJUTAMINE ==================}
{kui lahendamise kigus vastus leiti, siis tirjutab selle vljundfaili}
procedure kirjuta_vastus;
var valf : text; k, l : integer;
begin
 {vljundfaili loomine}
 assign(valf,valfail); rewrite(valf);

 if on_vastus then begin {vastus on olemas}
  {korrutise kirjutamine...}
  kirjuta_arv(vkorrutis,valf); writeln(valf);
  {tee pikkuse kirjutamine...}
  writeln(valf,vtee_pikkus);
  {tee enda kirjutamine...}
  l := alg; {l on kirjutatava tipu indeks}
  for k := 1 to vtee_pikkus do begin
   writeln(valf,l); {tipu indeksi vlja kirjutamine}
   l := vjarglane[l]; {jrgmise tipu indeks}
  end; {for k}
 end else {vastust ei leitud}
  writeln(valf,'VASTUS PUUDUB');

 {vljundfail kinni}
 close(valf);
end; {kirjuta_vastus}



{============== PEAPROGRAMM =================}
begin
 loe_andmed;
 lahenda;
 kirjuta_vastus;
end.