{ 020309N1.PAS                                                              }
{ 2002-03-09 programmeerimisolmpiaadi noorema rhma 1. lesande lahendus   }
{    RISTKLIKUD                                                            }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

const
   sisf = 'RIST.SIS';
   valf = 'RIST.VAL';

type
   punkt = record
      x, y : integer;
   end;
   ristk = record
      p1, p2 : punkt;
   end;

{ Leiab ristkliku pindala -- see vib olla suurem kui integer mahutab }
function pindala(r : ristk) : longint;
var dx, dy : longint;
begin
   dx := r.p1.x - r.p2.x;
   dy := r.p1.y - r.p2.y;
   pindala := abs(dx * dy);
end;

{ Leiab kahest antud arvust minimaalse }
function min(a1, a2 : integer) : integer;
begin
   if a1 > a2 then min := a2 else min := a1;
end;

{ Leiab kahest antud arvust maksimaalse }
function max(a1, a2 : integer) : integer;
begin
   if a1 < a2 then max := a2 else max := a1;
end;

{ Leiab ristklikute r1 ja r2 hisosa ning salvestab selle muutujasse r3 }
{ Tagastab true, kui hisosa on, false, kui seda pole }
function yhisosa(r1, r2 : ristk; var r3 : ristk) : boolean;
begin
   r3.p1.x := max(min(r1.p1.x, r1.p2.x), min(r2.p1.x, r2.p2.x));
   r3.p1.y := max(min(r1.p1.y, r1.p2.y), min(r2.p1.y, r2.p2.y));

   r3.p2.x := min(max(r1.p1.x, r1.p2.x), max(r2.p1.x, r2.p2.x));
   r3.p2.y := min(max(r1.p1.y, r1.p2.y), max(r2.p1.y, r2.p2.y));

   yhisosa := not (r3.p1.x > r3.p2.x) and not (r3.p1.y > r3.p2.y);
end;

var
   f : text;
   r1, r2, r3 : ristk;
begin
   assign(f, sisf); reset(f);
   readln(f, r1.p1.x, r1.p1.y, r1.p2.x, r1.p2.y);
   readln(f, r2.p1.x, r2.p1.y, r2.p2.x, r2.p2.y);
   close(f);

   assign(f, valf); rewrite(f);
   if yhisosa(r1, r2, r3) then
      writeln(f, pindala(r1) + pindala(r2) - pindala(r3))
   else
      writeln(f, pindala(r1) + pindala(r2));
   close(f);
end.
