{ 020309N3b.PAS                                                             }
{ 2002-03-09 programmeerimisolmpiaadi noorema rhma 3. lesande lahendus   }
{    KASSA                                                                  }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

const
   sisf = 'KASSA.SIS';
   valf = 'KASSA.VAL';
   maxn = 30;                                 { maksimaalne nominaalide arv }
   maxs = 10000;                                { maksimaalne makstav summa }

type
   olek = record
      n : integer;                         { mitu rahathte oleme kulutanud }
      i : integer;                      { viimase rahathe nominaali indeks }
   end;

var
   f : text;
   n : integer;                                           { nominaalide arv }
   a : array [1..maxn] of integer;                  { nominaalide vrtused }
   k : array [1..maxn] of integer;               { nominaalide arvud kassas }
   m : array [1..maxn] of integer;              { nominaalide vljamaksmine }
   o : array [0..maxs] of olek;                         { summade olekuruum }
   s, x : integer;                         { makstav summa ja jooksev summa }
   i, j : integer;         { jooksva nominaali ja jooksva eksemplari indeks }

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      read(f, a[i]);
   readln(f);
   for i := 1 to n do
      read(f, k[i]);
   readln(f);
   readln(f, s);
   close(f);

   { seame olekuruumi algseisu }
   o[0].n := 0;            { summa on saavutatav 0 rahathe vljamaksmisega }
   for x := 1 to s do
      o[x].n := -1;                             { summa on veel saavutamata }

   { tidame olekuruumi lainealgoritmiga }
   for i := n downto 1 do                        { vaatleme kiki nominaale }
      for j := 1 to k[i] do                    { nominaali kiki eksemplare }
         for x := s - a[i] downto 0 do                  { kiki algsummasid }
            if o[x].n > -1 then                { kui algsumma on saavutatav }
               { kui lppsumma ei ole seni veel saavutatav vi }
               { saavutame lppsumma nd vhemate rahathtedega }
               if (o[x + a[i]].n = -1) or
                     (o[x + a[i]].n > o[x].n + 1) then begin
                  { siis on uus variant }
                  o[x + a[i]].n := o[x].n + 1;
                  o[x + a[i]].i := i;
               end;

   { kui nutud summa pole saavutatav (vistlusel seda ei juhtu) }
   if o[s].n = -1 then begin
      writeln('Summa ', s, ' pole saavutatav');
      halt(1);
   end;

   { loendame kulutatud rahathed }
   for i := 1 to n do
      m[i] := 0;
   x := s;
   while x > 0 do begin
      m[o[x].i] := m[o[x].i] + 1;
      x := x - a[o[x].i];
   end;

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   for i := 1 to n - 1 do
      write(f, m[i], ' ');
   writeln(f, m[n]);
   close(f);
end.
