{ 020309V3b.PAS                                                             }
{ 2002-03-09 programmeerimisolmpiaadi vanema rhma 3. lesande lahendus    }
{    LINKER                                                                 }
{ Kirsto Tammeoja                                                           }
{ Testitud: FPC 1.0.4/GO32V2, TPC 6.0                                       }

{ Kasutab rekursiooni abil realiseeritud dnaamilist programmeerimist }

const
 {sisend- ja vljundfaili nimi}
 sisfail = 'linker.sis'; valfail = 'linker.val';
 MAX_TIPPE = 100; {maksimaalne tippude arv}
 MAX_SERVI = 1000; {maksimaalne servade arv}
 ARVU_MAX_PIKKUS = 200;
type
 v_arv = ^arv; {viit tbile arv}
 arv = record
  n : integer; {(tve)numbrite arv suures arvus (0-l ks)}
  sign : shortint; {vastavalt -1, 0 vi 1, kui suur arv on
   negatiivne 0 vi positiivne}
  nr : array[1..ARVU_MAX_PIKKUS] of byte;
 end;
 serv = record
  algus, lopp, kaal : integer; {serva alg- ja lpptipp ning serva kaal}
 end;
var
 n, m : integer; {tippude ja servade arv}
 alg, lopp : integer; {alg- ja lpptipu indeksid}

 {servade hoidmiseks}
 servad : array[1..MAX_SERVI] of serv; {servad}
 tipud : array[1..MAX_TIPPE+1] of integer; {iga tipu kohta on kirjutatud,
  mitmendast positsioonist massiivis servad algab sellest tipust vljuvate
  servade kirjeldus (viimase tipu jrel on kirjas, mitmenda positsiooniga
  servade kirjeldus lppeb); seega i-ndast tipust algavad servad on
  massiivis servad indekitega vahemikus [ tipud[i] .. tipud[i+1] )  }

 {vastus}
 on_vastus : boolean;
 vkorrutis : arv; {vastusena antava tee servade kaalude korrutis}
 vjarglane : array[1..MAX_TIPPE] of shortint; {iga tipu kohta kirjas vastusena
  antavas tees temale jrgneva tipu indeks}
 vtee_pikkus : integer; {vastusena antava tee pikkus}

 {lahendamise jaoks}
 tipud_teel : array[1..MAX_TIPPE] of integer; {tippude jrjekord teel}
 korrutised_teel : array[1..MAX_TIPPE] of v_arv;
 {jargnevas on 0 lihtsuse mottes nii positiivne kui ka negatiivne}
 {iga tipu jaoks jetakse meelde...}
 pos : array[1..MAX_TIPPE] of arv; {...positiivne arv}
 neg : array[1..MAX_TIPPE] of arv; {...negatiivne arv}
 {...ning kas on ikkagi leitud ...}
 on_pos : array[1..MAX_TIPPE] of boolean; {...positiivne arv}
 on_neg : array[1..MAX_TIPPE] of boolean; {...negatiivne arv}



{============= ARVUTAMISEGA SEOTUD MEETODID ==================}

{seab arvule a vrtuseks 1}
procedure anna1(var a : arv);
begin
 a.n := 1; a.sign := 1; a.nr[1] := 1;
end; {anna1}


{korrutab arvu a b-ga (b on vahemikus [-100...100])
 tulemus kirjutatakse muutujasse v}
procedure korruta(var a : arv; b : integer; var v : arv);
var l, y : integer; {loendur; ylekanne korrutamisel}
begin
 if (a.sign=0) or (b=0) then begin {ks tegur on null}
  v.n := 1; v.sign := 0; v.nr[1] := 0;
 end else begin {kumbki teguritest pole null}
  {korrutise mrk...}
  if b>0 then v.sign := a.sign else v.sign := -a.sign;

  {esimese n tvenumbri arvutamine...}
  v.n := a.n; {minimaalne vastuse tvenumbrite arv}
  y := 0; {esimese arvu juures on ylekanne null}
  b := abs(b); {tulemuse mrk on juba mratud,
   korrutamisega leitakse vaid tulemuse absoluutvrtus}

  for l := 1 to a.n do begin {l-nda numbri arvutamine}
   y := y+a.nr[l]*b; {}
   v.nr[l] := y mod 10; {tulemuse l-s number}
   y := y div 10; {ylekanne jrgmise taseme jaoks}
  end; {for l}

  {kui y pole null, siis jrelikult on korrutis esimesest tegurist pikem;
   leiame ka vastuse kige esimesed tvenumbrid}
  while y>0 do begin {lekanne on suurem, kui null...}
   inc(v.n); {vastuses tuleb vhemalt ks number juurde panna}
   v.nr[v.n] := y mod 10; {uue numbri kirjapanek}
   y := y div 10; {lekanne jrgmise sammu jaoks}
  end; {while y>0}
 end; {else - kumbki teguritest pole null}
end; {korruta}


{kirjutab arvu parameetrina antud tekstifaili, reavahetust ei lisata}
procedure kirjuta_arv(var a : arv; var f : text);
var l : integer;
begin
 if a.sign=-1 then write(f,'-'); {negatiivse arvu ette '-'}
 {numbrite kirjutamine - tuleb lihtsalt eestpoolt alates tvenumbrid
  vlja kirjutada (a.n on arvu tvenumbrite arv)}
 for l := a.n downto 1 do write(f,a.nr[l]);
end;


{tagastab positiivse arvu, nulli vi negatiivse arvu vastavalt sellele,
 kas esimene arvu on teisega vrreldes suurem, vrdne vi viksem}
function vordle(var a, b : arv) : integer;
var t, l : integer;
begin
 if a.sign=b.sign then begin {arvud sama mrgiga}
  {tvenumbrite vrdlemisel pole mtet, kui arvud on nullid}
  if a.sign=0{=b.sign} then begin vordle := 0; exit; end;

  {jrgnevalt vrreldaks a ja b aboluutvrtusi, tegeliku tulemuse saamiseks
   korrutatakse vrdluse tulemus a mrgiga (sama, mis b-l)}

  {a ja b on mlemad kas positiivsed vi mlemad negatiivsed}
  if a.n<>b.n then begin {kui arvudel on erinev arv tvenumbreid...}
   vordle := a.sign*(a.n-b.n); exit;
  end;

  {arvudel sama arv tvenumbreid}
  t := 0; {siia salvestataks a ja b absoluutvrtuste vrdluse tulemus}
  for l := a.n downto 1 do {arve vrreldakse vasakult paremale}
   if a.nr[l]<>b.nr[l] then begin {kui leitakse erinevus...}
    t := a.nr[l]-b.nr[l]; break;
   end;

  {kui tskli sees tvenumbrites erinevust ei leitud, siis t=0,
   muidu on t-s a ja b absoluutvrtuste vrdlemise tulemus}
  vordle := a.sign*(t); exit;
 end else begin {a.sign<>b.sign - arvud pole sama mrgiga}
  vordle := a.sign-b.sign; exit;
 end;
end; {vordle}



{============== ANDMETE LUGEMINE =================}
procedure loe_andmed;
var
 sisf : text; {sisendfail}
 k, l : integer;
 servad_a : array[1..MAX_SERVI] of serv; {servade lugemiseks}
begin
 assign(sisf,sisfail); reset(sisf);
 {graafi tippude ja servade arv}
 readln(sisf,n,m);
 {servade andmet lugemine}
 for l := 1 to m do
  readln(sisf,servad_a[l].algus,servad_a[l].lopp,servad_a[l].kaal);
 {alg- ja lppunkti lugemine}
 readln(sisf,alg,lopp);
 close(sisf);

 {tippude lhedusvektorite loomine.,,}

 {sorteerimine serva algpunkti jrgi...}
 {iga tipu kohta leitakse, mitu serva temast vljub}
 for l := 1 to n+1 do tipud[l] := 0; {loendurite nullimine}
 for l := 1 to m do inc(tipud[servad_a[l].algus]); {servade loendamine}
 {iga tipu kohta leitaks esimese serva indeks tidetavas massiivis servad,
  mis ei vlju antud tipust}
 inc(tipud[1]);
 for l :=  2 to n+1 do tipud[l] := tipud[l]+tipud[l-1];
 {servade kopeerimine nende igesse kohta}
 for l := 1 to m do begin
  k := servad_a[l].algus; {vaadeldava serva algustipp}
  dec(tipud[k]);
  servad[tipud[k]] := servad_a[l]; {serva kopeerimine igesse kohta}
 end;
 {massiivis tipud on nutavad indeksid}
end; {loe_andmed}



{================== LAHENDAMINE ====================}
{tidetakse vastuse kohta kivad andmed}

{kui parameetrina kirjeldatud tee on parem endisest parimast, siis
 salvestatakse uus vimalik vastus}
procedure uus_lahendus(var korrutis : arv; tippe : integer);
var l : integer;
begin
 {kui mingi lahendus on juba olemas ning uus korrutis on senini parimast
  viksem, siis uut vastust ei tule}
 if on_vastus and (vordle(korrutis,vkorrutis)<=0) then exit;

 {uus vastus}
 on_vastus := true; {mingi vastus on leitud}

 {korrutise vrtuse uuendamine}
 vkorrutis := korrutis;
 {uue tee pikkus}
 vtee_pikkus := tippe;
 {vastust kirjeldava vjarglane titmine}
 for l := 1 to tippe-1 do {massiivis vjarglane antakse igale tipule peale
  tema viimase jrglase indeks uues vimalikus vastuses}
  vjarglane[tipud_teel[l]] := tipud_teel[l+1];
 vjarglane[lopp] := lopp; {tee viimase elemendi jrglaseks seatakse ta ise}
end;{uus_lahendus}


{rekursiivne meetod.
 parameetriks antakse tipu jrjekorranumber tdeldaval teel.
 eeldatakse, et positiivne korrutis leidub (meelde jaetakse
 suurim positiivne ja vahim negatiivne korrutis - absoluutvaartuselt
 suuremad)}
procedure otsi_pos_tee(jrk : integer);
var
 tipp, l : integer;
 muudeti : boolean; {kas mingi serva lopptippu muudeti}
 korrutis : v_arv;
begin
 tipp := tipud_teel[jrk]; {praegu tdeldava tipu indeks}
 korrutis := korrutised_teel[jrk]; {et lyhem kirjutada oleks}

 {kui juti lpp-punkti, siis kontrollida, kas oli suurem korrutis}
 if (tipp=lopp) and (korrutis^.sign>=0) then begin
  uus_lahendus(korrutis^,jrk); exit;
 end;


 {pole veel lpp-punkti judnud}

 {kui mingi korrutis muutus praegu tulles paremaks...}
 muudeti := false;
 {...parem positiivne korrutis}
 if (korrutis^.sign>=0) and
     (not on_pos[tipp]) or (vordle(pos[tipp],korrutis^)<0) then begin
  on_pos[tipp] := true; pos[tipp] := korrutis^; muudeti := true;
 end;
 {...parem negatiivne korrutis}
 if (korrutis^.sign<=0) and
     (not on_neg[tipp]) or (vordle(neg[tipp],korrutis^)>0) then begin
  on_neg[tipp] := true; neg[tipp] := korrutis^; muudeti := true;
 end;

 {kui kumbki korrutis paremaks ei lainud, pole motet rabeleda}
 if not muudeti then exit;


 {proovib lbi kik vimalikud tee jtkamiseks}
 for l := tipud[tipp] to tipud[tipp+1]-1 do begin
  {jrgmise tipu mramine}
  tipud_teel[jrk+1] := servad[l].lopp;
  {jrgmisesse tippu minemisel tekkiva korrutise mramine}
  korruta(korrutis^,servad[l].kaal,korrutised_teel[jrk+1]^);

  otsi_pos_tee(jrk+1);
 end; {for l}
end; {otsi_pos_tee}


{rekursiivne meetod.
 parameetriks antakse tipu jrjekorranumber tdeldaval teel.
 eeldatakse, et positiivset korrutist ei leidnud (meelde jaetakse
 vahim positiivne ja suurim negatiivne korrutis - absoluutvaartuselt
 vaiksemad)}
procedure otsi_neg_tee(jrk : integer);
var
 tipp, l : integer;
 muudeti : boolean; {kas mingi serva lopptippu muudeti}
 korrutis : v_arv;
begin
 tipp := tipud_teel[jrk]; {praegu tdeldava tipu indeks}
 korrutis := korrutised_teel[jrk]; {et lyhem kirjutada oleks}

 {kui juti lpp-punkti, siis kontrollida, kas oli suurem korrutis}
 if tipp=lopp then begin
  uus_lahendus(korrutis^,jrk); exit;
 end;


 {pole veel lpp-punkti judnud}

 {kui mingi korrutis muutus praegu tulles paremaks...}
 muudeti := false;
 {...parem positiivne korrutis}
 if (korrutis^.sign>=0) and
     (not on_pos[tipp]) or (vordle(pos[tipp],korrutis^)>0) then begin
  on_pos[tipp] := true; pos[tipp] := korrutis^; muudeti := true;
 end;
 {...parem negatiivne korrutis}
 if (korrutis^.sign<=0) and
     (not on_neg[tipp]) or (vordle(neg[tipp],korrutis^)<0) then begin
  on_neg[tipp] := true; neg[tipp] := korrutis^; muudeti := true;
 end;

 {kui kumbki korrutis paremaks ei lainud, pole motet rabeleda}
 if not muudeti then exit;


 {proovib lbi kik vimalikud tee jtkamiseks}
 for l := tipud[tipp] to tipud[tipp+1]-1 do begin
  {jrgmise tipu mramine}
  tipud_teel[jrk+1] := servad[l].lopp;
  {jrgmisesse tippu minemisel tekkiva korrutise mramine}
  korruta(korrutis^,servad[l].kaal,korrutised_teel[jrk+1]^);

  otsi_neg_tee(jrk+1);
 end; {for l}
end; {otsi_neg_tee}


{lahendamise peameetod}
procedure lahenda;
var l : integer;
begin
 on_vastus := false; {senini pole vastus leitud...}


 {////////////////////}
 {kui korrutis tuleb positiivne (arvestatakse absoluutvrtuselt
  suuremaid korrutisi)}

 {mrkida, et tippude kohta pole veel korrutisi leitud}
 for l := 1 to n do begin
  on_pos[l] := false; on_neg[l] := false;
 end;

 {rekursiooni jaoks esimese tipu paika panemine}
 tipud_teel[1] := alg;
 anna1(korrutised_teel[1]^);

 {vastuse otsimine}
 otsi_pos_tee(1); {rekursiooni vljakutse positiivse tee leidmiseks}

 if on_vastus then exit; {kui positiivne tee leiti...}


 {////////////////////}
 {kui korrutis tuleb negatiivne (arvestatakse absoluutvrtuselt
  viksemaid korrutisi)}

 {mrkida, et tippude kohta pole veel korrutisi leitud}
 for l := 1 to n do begin
  on_pos[l] := false; on_neg[l] := false;
 end;

 {rekursiooni jaoks esimese tipu paika panemine}
 tipud_teel[1] := alg;
 anna1(korrutised_teel[1]^);

 {vastuse otsimine}
 otsi_neg_tee(1); {rekursiooni vljakutse negatiivse tee leidmiseks}
end; {lahenda}



{================== VASTUSE KIRJUTAMINE ==================}
{kui lahendamise kigus vastus leiti, siis tirjutab selle vljundfaili}
procedure kirjuta_vastus;
var valf : text; k, l : integer;
begin
 {vljundfaili loomine}
 assign(valf,valfail); rewrite(valf);

 if on_vastus then begin {vastus on olemas}
  {korrutise kirjutamine...}
  kirjuta_arv(vkorrutis,valf); writeln(valf);
  {tee pikkuse kirjutamine...}
  writeln(valf,vtee_pikkus);
  {tee enda kirjutamine...}
  l := alg; {l on kirjutatava tipu indeks}
  for k := 1 to vtee_pikkus do begin
   writeln(valf,l); {tipu indeksi vlja kirjutamine}
   l := vjarglane[l]; {jrgmise tipu indeks}
  end; {for k}
 end else {vastust ei leitud}
  writeln(valf,'VASTUS PUUDUB');

 {vljundfail kinni}
 close(valf);
end; {kirjuta_vastus}



{============== MALUGA TEGELEMINE ======================}
{meetodid korrutised_teel loomiseks ja kustutamiseks}

procedure tee_mas;
var l : integer;
begin
 for l := 1 to MAX_TIPPE do
  korrutised_teel[l] := new(v_arv);
end;

procedure kustuta_mas;
var l : integer;
begin
 for l := 1 to MAX_TIPPE do
  dispose(korrutised_teel[l]);
end;

{============== PEAPROGRAMM =================}
begin
 tee_mas;
 loe_andmed;
 lahenda;
 kirjuta_vastus;
 kustuta_mas;
end.